package com.natswell.corticon.helloapi;

import java.text.MessageFormat;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;

import com.corticon.eclipse.core.IModelAPIState;
import com.corticon.eclipse.core.impl.ModelAPIStateImpl;
import com.corticon.eclipse.studio.rule.rulesheet.core.IRulesheetDialogAPI;
import com.corticon.eclipse.studio.rule.rulesheet.core.RulesheetDialogAPIFactory;
import com.corticon.eclipse.studio.rule.rulesheet.table.core.IRulesheetTableModelAPI;
import com.corticon.eclipse.studio.rule.rulesheet.table.core.RulesheetTableModelAPIFactory;
import com.corticon.eclipse.studio.vocabulary.core.IEntity;
import com.corticon.eclipse.studio.vocabulary.core.IVocabularyDialogAPI;
import com.corticon.eclipse.studio.vocabulary.core.IVocabularyModelAPI;
import com.corticon.eclipse.studio.vocabulary.core.VocabularyDialogAPIFactory;
import com.corticon.eclipse.studio.vocabulary.tree.core.IVocabularyTreeModelAPI;
import com.corticon.eclipse.studio.vocabulary.tree.core.VocabularyTreeModelAPIFactory;

public class AssociatedAPIs2 {
    private static int count;
    
    public static void systemout(String message) {
        System.out.println(MessageFormat.format("{0,number,00}: {1}", ++count, message));
    }
    
    public static void main(String[] args) {
        final String vocabularyFileName = args[0];
        final String rulesheetFileName = args[1];

        // VocabularyVK쐬
        IVocabularyDialogAPI vocabularyDialogAPI = VocabularyDialogAPIFactory.getInstance();
        vocabularyDialogAPI.createVocabulary(URI.createFileURI(vocabularyFileName));

        // RulesheetVK쐬
        IRulesheetDialogAPI rulesheetDialogAPI = RulesheetDialogAPIFactory.getInstance();
        rulesheetDialogAPI.createRulesheet(
                RulesheetTableModelAPIFactory.getInstance(), 
                URI.createFileURI(rulesheetFileName), 
                URI.createFileURI(vocabularyFileName));

        // ҏWJn
        new AssociatedAPIs2().start(vocabularyFileName, rulesheetFileName);
    }

    public void start(String vocabularyFileName, String rulesheetFileName) {
    	IModelAPIState sharing = new ModelAPIStateImpl();
    	
        // VocabularyҏWJn
        VocabularyEditor vocabularyEditor = new VocabularyEditor(vocabularyFileName, sharing);
        vocabularyEditor.addEntity("i");
        vocabularyEditor.save();
        vocabularyEditor.addEntity("");

        // RulesheetҏWJn
        RulesheetEditor rulesheetEditor = new RulesheetEditor(rulesheetFileName, sharing);
        rulesheetEditor.addScopeEntity("i");
        rulesheetEditor.addScopeEntity("");
        vocabularyEditor.save();
        rulesheetEditor.addScopeEntity("");
        rulesheetEditor.load(rulesheetFileName);
        rulesheetEditor.addScopeEntity("");
        rulesheetEditor.save();

        // ㏈
        vocabularyEditor.dispose();
        rulesheetEditor.dispose();
    }

    class VocabularyEditor {
        private IVocabularyTreeModelAPI vocabularyAPI;
        private Resource resource;

        public VocabularyEditor(String fileName, IModelAPIState sharing) {
            systemout("Vocabulary> ҏWJniAPIj܂B");
            vocabularyAPI = VocabularyTreeModelAPIFactory.getInstance();
            vocabularyAPI.setModelAPIState(sharing);
            load(fileName);
        }
        
        public void load(String fileName) {
        systemout("Vocabulary> \[X[h܂B");
            resource = vocabularyAPI.loadResource(fileName);
        }

        public void addEntity(String name) {
            IEntity newEntity1 = vocabularyAPI.addEntity();
            vocabularyAPI.setEntityName(newEntity1, name);
            systemout("Vocabulary> GeBeB'" + name + "'bɒǉ܂B");
        }

        public void save() {
            vocabularyAPI.saveResource(resource);
            systemout("Vocabulary> ۑ܂B");
        }

        public void dispose() {
            vocabularyAPI.dispose();
        }
    }

    class RulesheetEditor {
        private IRulesheetTableModelAPI rulesheetAPI;
        private Resource resource;

        public RulesheetEditor(String fileName, IModelAPIState sharing) {
        	systemout("Rulesheet>  ҏWJniAPIj܂B");
            rulesheetAPI = RulesheetTableModelAPIFactory.getInstance();
            rulesheetAPI.setModelAPIState(sharing);
            load(fileName);
        }
        
        public void load(String fileName) {
            systemout("Rulesheet>  \[X[h܂B");
            resource = rulesheetAPI.loadResource(fileName);
        }

        public void addScopeEntity(String name) {
            IVocabularyModelAPI vocabularyAPI = rulesheetAPI.getVocabularyModelAPI();
            IEntity newEntity = vocabularyAPI.findEntity(name);
            if (newEntity != null) {
                rulesheetAPI.addScopeEntity(newEntity);
                systemout("Rulesheet>  GeBeB'" + name + "'XR[vɒǉ܂B");
            } else {
                systemout("Rulesheet>  GeBeB'" + name + "'݂͑܂BXR[vɓo^ł܂B");
            }
        }
        
        public void save() {
            rulesheetAPI.saveResource(resource);
            systemout("Rulesheet>  ۑ܂B");
        }

        public void dispose() {
            rulesheetAPI.dispose();
        }
    }
}
